<template>
    <div id="edition-container">
        <h1>Presentation</h1>
        <div class="uk-flex uk-flex-center">
            <div>
                <GobanEdition ref="goban" :situationInitiale="null" />
            </div>
            <div class="options uk-width-1-3">
                <PossibilitesCanvas
                    ref="possibilitesCanvas"
                    :afficher="true"
                    @actionUp="actionUp"
                    @actionDown="actionDown"
                    @actionRight="actionRight"
                    @actionLeft="actionLeft"
                />
                <Instructions
                    class="uk-margin-small-left"
                    ref="instructions"
                    :premierCommentaire="etatEdition.commentaireInitial"
                />
            </div>
        </div>
    </div>
</template>

<script lang="ts">
import Vue from 'vue';
import Component from 'vue-class-component';
import { newInstanceEtatEdition } from '../../views/Enseignement/editerprobleme/EtatEdition';
import GobanEdition from '../../views/Enseignement/editerprobleme/GobanEdition.vue';
import PossibilitesCanvas from '@/components/presentation/PossibilitesCanvas.vue';
import Instructions from '@/views/ModeJeu/commun/Instructions.vue';
import Probleme from '@/classes/Probleme';
import AvecPossibilites from '@/classes/AvecPossibilites';
import Possibilite from '@/classes/Possibilite';

@Component({
    components: {
        Instructions,
        GobanEdition,
        PossibilitesCanvas
    }
})
export default class PresentationProbleme extends Vue {
    etatEdition: any;

    created() {
        this.etatEdition = newInstanceEtatEdition();
        this.ajouterEventClavier(this);
    }

    ajouterEventClavier(self: PresentationProbleme) {
        window.addEventListener('keydown', function(event) {
            if (event.defaultPrevented) {
                return;
            }
            switch (event.key) {
                case 'ArrowLeft':
                    if (self.etatEdition.isDetail()) {
                        self.actionLeft();
                    }
                    break;
                case 'ArrowRight':
                    if (self.etatEdition.isDetail()) {
                        self.actionRight();
                    }
                    break;
                case 'ArrowUp':
                    if (self.etatEdition.isDetail()) {
                        self.actionUp();
                    }
                    break;
                case 'ArrowDown':
                    if (self.etatEdition.isDetail()) {
                        self.actionDown();
                    }
                    break;
            }
        });
    }

    public actionUp() {
        if (this.etatEdition.getIndexPossibilite() > 0) {
            this.modifierPosition(
                b => this.etatEdition.varierPossibiliteEnCours(b),
                false
            );
        }
    }

    public actionDown() {
        if (
            this.etatEdition.getIndexPossibilite() <
            this.etatEdition.possibilites.length - 1
        ) {
            this.modifierPosition(
                b => this.etatEdition.varierPossibiliteEnCours(b),
                true
            );
        }
    }

    public actionLeft() {
        if (this.etatEdition.getIndexPierre() >= 0) {
            this.modifierPosition(
                b => this.etatEdition.varierCoupEnCours(b),
                false
            );
        }
    }

    public actionRight() {
        if (
            this.etatEdition.getIndexPierre() <
            this.etatEdition.possibiliteEnCours.getCoups().length - 1
        ) {
            this.modifierPosition(
                b => this.etatEdition.varierCoupEnCours(b),
                true
            );
        }
    }

    private modifierPosition(
        modificateur: { (b: boolean): void },
        modif: boolean
    ) {
        this.$root.$emit('enregistrerCommentaire');
        this.etatEdition.modifierPosition(modificateur, modif, true);
        this.$root.$emit('modifierPosition', true);
    }

    public decomposerProbleme(probleme: Probleme) {
        this.etatEdition.tailleGoban = probleme.getPosition().tailleGoban;
        this.etatEdition.position = probleme.getPosition();
        this.etatEdition.pierresBlanches = probleme
            .getSituationInitiale()
            .filter(coup => coup.getCouleur() === 'BLANC');
        this.etatEdition.pierresNoires = probleme
            .getSituationInitiale()
            .filter(coup => coup.getCouleur() === 'NOIR');
        this.etatEdition.marqueurs = probleme.getMarqueursInitiaux();
        if (probleme instanceof AvecPossibilites) {
            this.etatEdition.possibilites = ((probleme as unknown) as AvecPossibilites).getPossibilites();
            this.etatEdition.possibiliteEnCours = this.etatEdition.possibilites[0];
        }
        if (this.etatEdition.possibilites.length === 0) {
            this.etatEdition.possibiliteEnCours = new Possibilite();
            this.etatEdition.possibilites.push(
                this.etatEdition.possibiliteEnCours
            );
        }
    }
}
</script>
